import Vue from 'vue'
export function createDom (Component, {props, on}, callback) {
  const comp = new (Vue.extend(Component))({propsData: props}).$mount()
  comp.$on('click', (data) => {
    on.click(data)
  })
  document.body.appendChild(comp.$el)
  const click = (e) => {
    if (e.target !== comp.$el) {
      comp.remove()
    }
  }

  document.body.addEventListener('click', click)
  comp.remove = () => {
    document.body.removeChild(comp.$el)
    document.body.removeEventListener('click', click)
    comp.$destroy()
    typeof callback === 'function' && callback()
  }

  return comp
}
