import * as echarts from 'echarts'
import { debounce } from '../../utils';

export default {
  name: 'LxEcharts',
  props: {
    delay: {
      type: Number,
      default: 100
    }
  },
  data () {
    return {
      echarts: null,
      instance: null,
      onResize: null
    }
  },
  methods: {
    getEcharts () {
      return this.echarts
    },
    getInstance () {
      return this.instance
    },
    setOption (options) {
      this.instance.setOption(options)
    }
  },
  render (h) {
    return h('div', {
      ref: 'lxEcharts',
      style: {
        width: '100%',
        height: '100%'
      }
    })
  },
  created() {
  },
  mounted() {
    this.instance = echarts.init(this.$refs.lxEcharts)
    this.echarts = echarts
    window.addEventListener('resize', debounce(() => {
      this.instance.resize()
    }, this.delay))
  },
  beforeDestroy() {
    window.removeEventListener('resize', debounce(() => {
      this.instance.resize()
    }, this.delay))
  }
}
