import { Checkbox, CheckboxButton, CheckboxGroup} from "element-ui";

/**
 * 处理 checkbox 复选框组件
 * @param item 当前项的表单数据
 * @param renderOptions 整理好的表单属性
 * @param h createElement
 * */
export function handlerCheckboxItem(h, item, renderOptions) {
  return handlerCheckboxBase.call(this, Checkbox, { h, item, renderOptions})
}
export function handlerCheckboxButtonItem(h, item, renderOptions) {
  return handlerCheckboxBase.call(this, CheckboxButton, { h, item, renderOptions})
}
export function handlerCheckboxBase(component, { h, item, renderOptions }) {
  const fm = this
  const {options, optionsConfig = [], filed, on = {}} = item
  const { value, isEdit } = renderOptions.props
  if (!isEdit) {
    const content = []
    if (value && value.length) {
      for (let i = 0; i < options.length; i++) {
        const item = options[i]
        if (value.includes(item.value)) {
          content.push(item.label)
        }
      }
    }
    return h('span', null, content.toString())
  }

  const checkboxs = []

  options.forEach((item, index) => {
    let checkboxOptions = {
      props: {
        label: item.value
      }
    }
    if (optionsConfig[index]) {
      checkboxOptions = {
        ...optionsConfig[index],
        props: {
          ...optionsConfig[index].props,
          ...checkboxOptions.props
        }
      }
    }
    checkboxs.push(h(component, checkboxOptions, item.label))
  })
  const propsValue = Array.isArray(value) ? value : []

  return h(CheckboxGroup, {
    ...renderOptions,
    props: {
      ...renderOptions.props,
      value: propsValue
    }
  }, checkboxs)
}
