import {Select, Option} from 'element-ui';

/**
 * 处理 select 列表
 * @param h form组件的createElement
 * @param item 当前项的表单数据
 * @param renderOptions 整理好的表单属性
 * */
export function handlerSelect (h, item, renderOptions) {
  const { options = [] } = item
  const { on = {} } = renderOptions

  if (!renderOptions.props.isEdit) {
    const value = renderOptions.props.value
    const match = options.find((item) => {
      return item.value === value
    })
    return h('div', match ? match.label : value)
  }

  const optionsDom = options.map((option) => {
    return h(Option, {
      props: {
        ...option
      },
      nativeOn: {
        click: (e) => {
          typeof on.select === 'function' && on.select(option)
        }
      }
    })
  })
  return h(Select, renderOptions, optionsDom)
}
