import {
  ColorPicker,
  Transfer,
  Switch,
  Slider
} from 'element-ui'

import { handlerUploadImgItem } from './built-in/upload';
import {
  handlerInputNumberItem,
  handlerSelect,
  handlerCheckboxItem,
  handlerCheckboxButtonItem,
  handlerRadioItem,
  handlerRadioButtonItem,
  handlerCascader,
  handlerTimeRange,
  handlerTime,
  handlerDate,
  handlerDateRange,
  handlerDateTime,
  handlerDateTimeRange,
  handlerInput,
  DefaultTimeSelect,
  DefaultDatePicker,
  handlerUploadItem
} from './components'
import { handlerDigitSelect } from './built-in/digit-select';

export const FormComponents = {
  'input': handlerInput,
  'enum': handlerSelect,
  'time-select': DefaultTimeSelect,
  'date-picker': DefaultDatePicker,
  'date': handlerDate,
  'date-range': handlerDateRange,
  'date-time': handlerDateTime,
  'date-time-range': handlerDateTimeRange,
  'time-range': handlerTimeRange,
  'time': handlerTime,
  'input-number': handlerInputNumberItem,
  'cascader': handlerCascader,
  'color': ColorPicker,
  'transfer': Transfer,
  'switch': Switch,
  'slider': Slider,
  'checkboxButton': handlerCheckboxButtonItem,
  'checkbox': handlerCheckboxItem,
  'radioButton': handlerRadioButtonItem,
  'radio': handlerRadioItem,
  'upload': handlerUploadItem,
  'uploadImg': handlerUploadImgItem,
  'digit-select': handlerDigitSelect
}
