import {effectiveValue, getValue, isArray} from "../../../utils";

export function handlerEnum(h, item) {
  const {filed, options, optionColors, enumKey, enumLabelKey} = item
  return (e) => {
    if (!effectiveValue(filed)) {
      console.error('"filed" is required. the problem is in the ', item)
      return
    }
    const value = getValue(e.row, filed)
    const valueKey = effectiveValue(enumKey) ? enumKey : 'value'
    const labelKey = effectiveValue(enumLabelKey) ? enumLabelKey : 'label'

    let _insideInfo = {
      index: ''
    }
    const match = options.find((item, i) => {
      const flag = item[valueKey] === value
      if (flag) {
        _insideInfo.index = i
      }
      return flag
    })
    if (match) {
      if (optionColors && !isArray(optionColors)) {
        console.error('"optionColors" should is a Array. the problem is in the ', item)
      }

      if (isArray(optionColors) && optionColors.length) {
        return setEnumColors(h, match[labelKey], _insideInfo.index, optionColors)
      }
      return h('span', null, match[labelKey])
    }

  }
}

function setEnumColors(h, content, index, colors = []) {
  const style = {
    color: colors[index] || colors[0]
  }
  return h('span', {
    style
  }, content)
}
