import {handlerThousands, getValue} from "../../../utils";

/**
 * 处理千分位
 * */
export function handlerThousandsTD (h, item) {
  const { filed, precision } = item
  return (e) => {
    const value = handlerThousands(getValue(e.row, filed), precision)
    if (value) {
      return h('span', null, value)
    }
  }
}

/**
 * 处理百分数据，乘以100，添加百分号
 * */
export function handlerPercentage (h, item) {
  const { filed, precision = 2 } = item
  return (e) => {
    const value = getValue(e.row, filed)
    if (typeof value === 'number') {
      const str = (value * 100).toFixed(precision) + '％'
      return h('span', null, str)
    }
  }
}
/**
 * 处理千分数据，乘以1000，添加千分号
 * */
export function handlerPerMill (h, item) {
  const { filed, precision = 2 } = item
  return (e) => {
    const value = getValue(e.row, filed)
    if (typeof value === 'number') {
      const str = (value * 1000).toFixed(precision) + '‰'
      return h('span', null, str)
    }
  }
}
