import { getValue } from "../../../utils";
import { Image } from "element-ui";

export function handlerImage (h, item) {
  const { filed, filedPrimaryKey, imageStyle = {} } = item
  const { width, height, objectFit } = imageStyle
  return (e) => {
    let imgVal = getValue(e.row, filed)
    if (Array.isArray(imgVal)) {
      if (typeof imgVal[0] === 'object') {
        imgVal = imgVal.map((item) => {
          return getValue(item, filedPrimaryKey)
        })
      }
    } else {
      imgVal = [imgVal]
    }

    return h(Image, {
      props: {
        src: imgVal[0],
        previewSrcList: imgVal,
        fit: objectFit || 'cover'
      },
      style: {
        width: width || '100%',
        height: height || '100%'
      }
    })
  }
}
