import {isObject} from '../../../utils'
import {Checkbox} from 'element-ui';

export function handlerCheckboxHead (h, item) {
  if (isObject(item.attrs)) {
    item.attrs.renderHeader = item.attrs.renderHeader || createCheckboxHead.bind(this)
  } else {
    item.attrs = {
      renderHeader: createCheckboxHead.bind(this)
    }
  }
  return item
}
export function createCheckboxHead(h, { column, $index }) {
  return h(Checkbox, {
    props: {
      value: this.allSelection.checked,
      indeterminate: this.allSelection.indeterminate,
      disabled: this.allSelection.disabled
    },
    on: {
      change: (val) => {
        this.allSelection.checked = val
        this.switchSelectionAll(val)
      }
    }
  })
}

export function createCheckbox (h) {
  return (e) => {
    return h(Checkbox, {
      props: {
        value: e.row['__checked__']
      },
      on: {
        change: (val) => {
          e.row['__checked__'] = val
          const tableSelected = this.tableSelected
          checkChangeArr(tableSelected, e.row, this.primaryKey, val)
        }
      }
    })
  }
}

export function checkChangeArr(source, newData, key, status) {
  if (status) {
    if (source.indexOf(newData)  === -1) {
      source.push(newData)
    }
  } else {
    const len = source.length
    for (let i = 0; i < len; i++) {
      if (source[i][key] === newData[key]) {
        source.splice(i, 1)
        break
      }
    }
  }
  return source
}

export function initHeadCheckboxStatus (selected, tableData) {
  const tableLen = tableData.length
  const valLen = selected.length
  if (tableLen < 1) {
    this.allSelection.checked = false
    this.allSelection.indeterminate = false
    this.allSelection.disabled = true
    return
  }
  if (valLen < 1) {
    this.allSelection.checked = false
    this.allSelection.indeterminate = false
    return
  }

  if (valLen > 0 && valLen !== tableLen) {
    this.allSelection.checked = false
    this.allSelection.indeterminate = true
    return
  }

  if (tableLen === valLen) {
    this.allSelection.indeterminate = false
    this.allSelection.checked = true
  }
}
