import { searchConfigOption } from '../../utils/handlerConfig';
import { createTable } from './table-utils';
import SelectionMixin from './selection/mixin'

export default {
  name: 'lx-table',
  mixins: [SelectionMixin],
  components: {},
  props: {
    tableAttr: {
      type: Object,
      default () {
        return {}
      }
    },
    data: {
      type: Array,
      default () {
        return []
      }
    },
    columns: {
      type: Array,
      default () {
        return []
      }
    },
    loading: {
      type: Boolean,
      default: false
    },
    primaryKey: {
      type: [String, Number],
      default: ''
    }
  },
  data () {
    return {
      tableData: []
    }
  },
  created () {
  },
  mounted () {
  },
  watch: {
    data: {
      handler (val) {
        this.initTable(val)
        this.initSelected()
      },
      deep: true,
      immediate: true
    },
  },
  methods: {
    searchConfig ({ key, value }) {
      return searchConfigOption(this.columns, { key, value })
    },
    getRef () {
      return this.$refs.lxTable
    }
  },
  render (h) {
    console.log('this.tableAttr', this.tableAttr)
    const Table = createTable.call(
      this,
      h,
      this.tableData,
      this.columns,
      this.tableAttr
    )
    return (
      Table
    )
  }
}
