export function searchConfigOption (config, { key, value }) {
  return findConfigData(config, { key, value })
}

// 查询 config里的某一项数据
export function findConfigData (config, { key, value }) {
  if (!Array.isArray(config)) {
    return config
  }

  let res = []

  const len = config.length
  for (let i = 0; i < len; i++) {
    if (config[i][key] === value) {
      res.push(config[i])
    }

    if (config[i].children && !Array.isArray(config[i].children)) {
      console.error('children is not array!')
    }

    if (config[i].children) {
      res = res.concat(findConfigData(config[i].children, { key, value }))
    }
  }

  return res
}
